#include <Xm/Xm.h>
#include <Xm/MessageB.h>
#include <Xm/Form.h>
#include <Xm/Frame.h>
#include <Xm/RowColumn.h>
#include <Xm/DrawingA.h>
#include <Xm/LabelG.h>
#include <Xm/ToggleBG.h>
#include <Xm/Scale.h>
#include <Xm/Text.h>
#include <stdlib.h>
#include <sys/types.h>
#include <unistd.h>
#include <math.h>
#include "../modules/control.h"
#include "global.h"

#define TRIGGER_COLOR "red"  // color of trigger channel;

void derived_cb(Widget widget, XtPointer client_data, XtPointer call_data) {
         Widget        dialog, form, cb_frame, check_box, slider1, slider2, slider3, slider4;
	 Widget        da_frame, draw_a, w;
  struct my_msg_struct msg;
         int           chn, i, c, p;

  void    dia_ok_cb(Widget widget, XtPointer client_data, XtPointer call_data);
  void    dia_cancel_cb(Widget widget, XtPointer client_data, XtPointer call_data);
  void    select_derived_cb(Widget widget, XtPointer client_data, XtPointer call_data);
  void    color_derived_cb(Widget widget, XtPointer client_data, XtPointer call_data);
  void    height_derived_cb(Widget widget, XtPointer client_data, XtPointer call_data);
  void    der_da_cb(Widget widget, XtPointer client_data, XtPointer call_data);
  void    der_rs_cb(Widget widget, XtPointer client_data, XtPointer call_data);
  void    threshold_cb(Widget widget, XtPointer client_data, XtPointer call_data);
  void    movavg_cb(Widget widget, XtPointer client_data, XtPointer call_data);
  void    tl_cb(Widget widget, XtPointer client_data, XtPointer call_data);
  void    ampli_cb(Widget widget, XtPointer client_data, XtPointer call_data);
  Boolean derived_rec(XtPointer client_data);

  der.store=(int)client_data; // missuse to store channel number to derive from;
  chn=der.store;

  /* create dialog box */
  dialog=XmCreateMessageDialog(drawing_a, "dialog", NULL, 0);
  XtVaSetValues(XtParent(dialog),
		XmNtitle, "Setup derived channels",
		NULL);
  XtAddCallback(dialog, XmNokCallback, dia_ok_cb, (XtPointer) widget);
  XtAddCallback(dialog, XmNcancelCallback, dia_cancel_cb, NULL);
  
  form=XtVaCreateWidget("form", xmFormWidgetClass, dialog,
			NULL);
  slider4=XtVaCreateWidget("slider", xmScaleWidgetClass, form,
			   XtVaTypedArg, XmNtitleString, XmRString, "moving average", 14,
			   XmNmaximum, 500,
			   XmNminimum, 1,
			   XmNshowValue, True,
			   XmNorientation, XmHORIZONTAL,
			   XmNleftAttachment, XmATTACH_FORM,
			   XmNrightAttachment, XmATTACH_FORM,
			   XmNbottomAttachment, XmATTACH_FORM,
			   NULL);
  XtVaSetValues(slider4, XmNvalue, dch[der.store].movavg, NULL);
  der.movavg=dch[der.store].movavg;
  XtAddCallback(slider4, XmNvalueChangedCallback, movavg_cb, NULL);
  slider3=XtVaCreateWidget("slider", xmScaleWidgetClass, form,
			   XtVaTypedArg, XmNtitleString, XmRString, "amplification", 13,
			   XmNmaximum, 100,
			   XmNminimum, 1,
			   XmNshowValue, True,
			   XmNorientation, XmHORIZONTAL,
			   XmNleftAttachment, XmATTACH_FORM,
			   XmNrightAttachment, XmATTACH_FORM,
			   XmNbottomAttachment, XmATTACH_WIDGET,
			   XmNbottomWidget, slider4,
			   NULL);
  XtVaSetValues(slider3, XmNvalue, dch[der.store].ampli, NULL);
  XtAddCallback(slider3, XmNvalueChangedCallback, ampli_cb, NULL);
  slider2=XtVaCreateWidget("slider", xmScaleWidgetClass, form,
			   XtVaTypedArg, XmNtitleString, XmRString, "trace length (sec.)", 19,
			   XmNmaximum, 300,
			   XmNminimum, 1,
			   XmNshowValue, True,
			   XmNorientation, XmHORIZONTAL,
			   XmNleftAttachment, XmATTACH_FORM,
			   XmNrightAttachment, XmATTACH_FORM,
			   XmNbottomAttachment, XmATTACH_WIDGET,
			   XmNbottomWidget, slider3,
			   NULL);
  XtVaSetValues(slider2, XmNvalue, der.length, NULL);
  XtAddCallback(slider2, XmNvalueChangedCallback, tl_cb, NULL);
  slider1=XtVaCreateWidget("slider", xmScaleWidgetClass, form,
			   /* XtVaTypedArg, XmNtitleString, XmRString, "trigger", 7, */
			   XmNmaximum, 4095,
			   XmNminimum, 0,
			   XmNshowValue, True,
			   XmNorientation, XmVERTICAL,
			   XmNtopAttachment, XmATTACH_FORM,
			   XmNbottomAttachment, XmATTACH_WIDGET,
			   XmNbottomWidget, slider2,
			   XmNleftAttachment, XmATTACH_FORM,
			   NULL);
  XtVaSetValues(slider1, XmNvalue, dch[der.store].threshold, NULL);
  XtAddCallback(slider1, XmNvalueChangedCallback, threshold_cb, NULL);
  XtAddCallback(slider1, XmNdragCallback, threshold_cb, NULL);

  cb_frame=XtVaCreateWidget("frame", xmFrameWidgetClass, form,
			    XmNtopAttachment, XmATTACH_FORM,
			    XmNrightAttachment, XmATTACH_FORM,
			    XmNbottomAttachment, XmATTACH_WIDGET,
			    XmNbottomWidget, slider2,
			    NULL);
  XtVaCreateManagedWidget("select derived channels", xmLabelGadgetClass, cb_frame,
			  XmNchildType, XmFRAME_TITLE_CHILD,
			  NULL);

  // create rowcolumn widget for derived channel setup;
  check_box=XtVaCreateWidget("togglebox",
			     xmRowColumnWidgetClass, cb_frame,
			     XmNpacking, XmPACK_COLUMN,
			     XmNnumColumns, 3,
			     XmNchildType, XmFRAME_WORKAREA_CHILD,
			     NULL);
  // create and set toggles for active;
  w=XtVaCreateManagedWidget("frequency", xmToggleButtonGadgetClass, check_box, NULL);
  XtAddCallback(w, XmNvalueChangedCallback, select_derived_cb, (void *) 0);
  if (dch[chn].ch[0].active) XmToggleButtonGadgetSetState(w,True,False);
  w=XtVaCreateManagedWidget("maximum", xmToggleButtonGadgetClass, check_box, NULL);
  XtAddCallback(w, XmNvalueChangedCallback, select_derived_cb, (void *) 1);
  if (dch[chn].ch[1].active) XmToggleButtonGadgetSetState(w,True,False);
  w=XtVaCreateManagedWidget("mean", xmToggleButtonGadgetClass, check_box, NULL);
  XtAddCallback(w, XmNvalueChangedCallback, select_derived_cb, (void *) 2);
  if (dch[chn].ch[2].active) XmToggleButtonGadgetSetState(w,True,False);
  w=XtVaCreateManagedWidget("minimum", xmToggleButtonGadgetClass, check_box, NULL);
  XtAddCallback(w, XmNvalueChangedCallback, select_derived_cb, (void *) 3);
  if (dch[chn].ch[3].active) XmToggleButtonGadgetSetState(w,True,False);
  w=XtVaCreateManagedWidget("amplitude", xmToggleButtonGadgetClass, check_box, NULL);
  XtAddCallback(w, XmNvalueChangedCallback, select_derived_cb, (void *) 4);
  if (dch[chn].ch[4].active) XmToggleButtonGadgetSetState(w,True,False);
  w=XtVaCreateManagedWidget("dy/dt_max", xmToggleButtonGadgetClass, check_box, NULL);
  XtAddCallback(w, XmNvalueChangedCallback, select_derived_cb, (void *) 5);
  if (dch[chn].ch[5].active) XmToggleButtonGadgetSetState(w,True,False);
  w=XtVaCreateManagedWidget("dy/dt_min", xmToggleButtonGadgetClass, check_box, NULL);
  XtAddCallback(w, XmNvalueChangedCallback, select_derived_cb, (void *) 6);
  if (dch[chn].ch[6].active) XmToggleButtonGadgetSetState(w,True,False);

  // create and set toggles for color;
  for (i=0; i<7; i++) {
    XtManageChild(XmVaCreateSimpleOptionMenu(check_box, "color",
		  XmStringCreateLocalized(""), ' ', dch[chn].ch[i].color, color_derived_cb,
		  XmVaPUSHBUTTON, XmStringCreateLocalized(colors[0]), ' ', NULL, NULL,
		  XmVaPUSHBUTTON, XmStringCreateLocalized(colors[1]), ' ', NULL, NULL,
		  XmVaPUSHBUTTON, XmStringCreateLocalized(colors[2]), ' ', NULL, NULL,
                  XmVaPUSHBUTTON, XmStringCreateLocalized(colors[3]), ' ', NULL, NULL,
		  XmVaPUSHBUTTON, XmStringCreateLocalized(colors[4]), ' ', NULL, NULL,
		  XmVaPUSHBUTTON, XmStringCreateLocalized(colors[5]), ' ', NULL, NULL,
		  XmVaPUSHBUTTON, XmStringCreateLocalized(colors[6]), ' ', NULL, NULL,
		  XmVaPUSHBUTTON, XmStringCreateLocalized(colors[7]), ' ', NULL, NULL,
		  XmNuserData, i,
		  NULL)
		  );
  }
  // create and set toggles for height;
  for (i=0; i<7; i++) {
    XtManageChild(XmVaCreateSimpleOptionMenu(check_box, "height",
		  XmStringCreateLocalized(""), ' ', dch[chn].ch[i].height, height_derived_cb,
                  XmVaPUSHBUTTON, XmStringCreateLocalized("width=1"), ' ', NULL, NULL,
		  XmVaPUSHBUTTON, XmStringCreateLocalized("width=2"), ' ', NULL, NULL,
		  XmVaPUSHBUTTON, XmStringCreateLocalized("width=3"), ' ', NULL, NULL,
		  XmVaPUSHBUTTON, XmStringCreateLocalized("width=4"), ' ', NULL, NULL,
		  XmNuserData, i,
		  NULL)
		  );
  }

  XtManageChild(check_box);
  XtManageChild(cb_frame);

  da_frame=XtVaCreateWidget("frame", xmFrameWidgetClass, form,
			    XmNtopAttachment, XmATTACH_FORM,
			    XmNleftAttachment, XmATTACH_WIDGET,
			    XmNleftWidget, slider1,
			    XmNrightAttachment, XmATTACH_WIDGET,
			    XmNrightWidget, cb_frame,
			    XmNbottomAttachment, XmATTACH_WIDGET,
			    XmNbottomWidget, slider2,
			    NULL);
  XtVaCreateManagedWidget("trigger signal", xmLabelGadgetClass, da_frame,
			  XmNchildType, XmFRAME_TITLE_CHILD,
			  NULL);
  draw_a=XtVaCreateManagedWidget("draw", xmDrawingAreaWidgetClass, da_frame,
				 XmNwidth, 300,
				 XmNchildType, XmFRAME_WORKAREA_CHILD,
				 NULL);
  XtAddCallback(draw_a, XmNexposeCallback, der_da_cb, NULL);
  XtAddCallback(draw_a, XmNresizeCallback, der_rs_cb, NULL);

  XtManageChild(da_frame);
  XtManageChild(slider1);
  XtManageChild(slider2);
  XtManageChild(slider3);
  XtManageChild(slider4);

  XtManageChild(form);
  XtManageChild(dialog);

  /* start sampling */
  XtVaGetValues(draw_a, XmNwidth, &der.xpix, NULL);
  der.nbuf = der.length*reg.sr/der.xpix;
  if (der.nbuf<1) {
    der.nbuf=1;
    der.length=der.nbuf*der.xpix/reg.sr;
  }
  der.resize=0;
  c=(int)pow(2,der.store);
  if (ch[der.store].polarity) p=(int)pow(2,der.store); else p=0;
  ch[der.store].buf = (char *)realloc(ch[der.store].buf, der.nbuf*2);
  ch[der.store].min = (int *)realloc(ch[der.store].min, der.xpix*sizeof(int));
  ch[der.store].max = (int *)realloc(ch[der.store].max, der.xpix*sizeof(int));
  ch[der.store].first=0; ch[der.store].last=0;
  ch[der.store].addfirst=0; ch[der.store].xpos=0; ch[der.store].nread=0;
  dch[der.store].mavg=(int *)realloc(dch[der.store].mavg, dch[der.store].movavg*sizeof(int));
  dch[der.store].masum=0;
  for (i=0; i<dch[der.store].movavg; i++) dch[der.store].mavg[i]=0;
  msg.command=SET_SR; msg.value=reg.sr;
  write(fd8, &msg, sizeof(msg));
  msg.command=SET_CH; msg.value=c;
  write(fd8, &msg, sizeof(msg));
  msg.command=SET_POL; msg.value=p;
  write(fd8, &msg, sizeof(msg));
  msg.command=START_TASK; msg.value=0;
  write(fd8, &msg, sizeof(msg));
  work_id=XtAppAddWorkProc(app, derived_rec, (XtPointer)draw_a);

}

/* ............................. */ 
/* ...   c a l l b a c k s   ... */
/* ............................. */ 
void select_derived_cb(Widget widget, XtPointer client_data, XtPointer call_data) {
         Widget   shell, mbox, rowcol;
  static Widget   limitw[2];
         Arg      args[5];
         XmString msg;
         int      argc=0;
         int      i=(int) client_data;
	 char     text[255];
  XmToggleButtonCallbackStruct *toggle_data = (XmToggleButtonCallbackStruct *) call_data;

  void set_limit_cb(Widget widget, XtPointer client_data, XtPointer call_data);
  void cancel_limit_cb(Widget widget, XtPointer client_data, XtPointer call_data);

  if (toggle_data->set) {
    dch[der.store].nch++;
    dch[der.store].ch[i].active=1;
    der.nactive++;
    if (i==0 || i==5 || i==6) {
      switch (i) {
      case 0:
	XtSetArg(args[argc], XmNtitle, "range for frequency"); argc++;
	msg=XmStringCreateLocalized("set range for frequency:");
	break;
      case 5:
	XtSetArg(args[argc], XmNtitle, "range for dy/dt_max"); argc++;
	msg=XmStringCreateLocalized("set range for dy/dt_max:");
	break;
      case 6:
	XtSetArg(args[argc], XmNtitle, "range for dy/dt_min"); argc++;
	msg=XmStringCreateLocalized("set range for dy/dt_min:");
	break;
      }
      XtSetArg(args[argc], XmNautoUnmanage, False); argc++;
      shell=widget;
      while (!XtIsShell(shell)) shell=XtParent(shell);
      mbox=XmCreateMessageDialog(shell, "range", args, argc);
      XtVaSetValues(mbox,
		    XmNmessageString, msg,
		    XmNuserData, i,
		    NULL);
      XtUnmanageChild(XmMessageBoxGetChild(mbox, XmDIALOG_HELP_BUTTON));
      rowcol=XtVaCreateWidget("rowcol", xmRowColumnWidgetClass, mbox,
			      XmNorientation, XmHORIZONTAL,
			      XmNpacking, XmPACK_COLUMN,
			      XmNnumColumns, 2,
			      NULL);
      XtVaCreateManagedWidget("lower limit: ",xmLabelGadgetClass, rowcol,
			      NULL);
      limitw[0]=XtVaCreateManagedWidget("text", xmTextWidgetClass, rowcol,
			      NULL);
      sprintf(text,"%f", dch[der.store].ch[i].cal.rw_low);
      XmTextSetString(limitw[0], text);
      XtVaCreateManagedWidget("upper limit: ",xmLabelGadgetClass, rowcol,
			      NULL);
      limitw[1]=XtVaCreateManagedWidget("text", xmTextWidgetClass, rowcol,
			      NULL);
      sprintf(text,"%f", dch[der.store].ch[i].cal.rw_high);
      XmTextSetString(limitw[1], text);
      XtAddCallback(mbox, XmNokCallback, set_limit_cb, limitw);
      XtAddCallback(mbox, XmNcancelCallback, cancel_limit_cb, NULL);
      XtManageChild(rowcol);
      XtManageChild(mbox);
      XtPopup(XtParent(mbox), XtGrabNone);
      XmStringFree(msg);
    }
  }
  else {
    dch[der.store].nch--;
    dch[der.store].ch[i].active=0;
    der.nactive--;
  }
}

void color_derived_cb(Widget widget, XtPointer client_data, XtPointer call_data) {
  int i;
  XtVaGetValues(XtParent(widget), XmNuserData, &i, NULL);
  dch[der.store].ch[i].color=(int)client_data;
}

void height_derived_cb(Widget widget, XtPointer client_data, XtPointer call_data) {
  int i;
  XtVaGetValues(XtParent(widget), XmNuserData, &i, NULL);
  dch[der.store].ch[i].height=(int)client_data;
}

Boolean derived_rec(XtPointer client_data) {
         int    i, j, k, chan, wert, dwert, bmin, bmax;
	 unsigned long ma;
  static int    wert1=0;
  static int    wert2=0;
  static int    map=0;
  static int    lmin=0, godown=0;
         int    drawit;
         char   *w, buf[2];
         Widget draw_a;

  void der_redraw(Widget drawing_a);

  draw_a=(Widget) client_data;
  w=(char*) &wert;

  drawit=1; 
  ch[der.store].nread+=read(fd[der.store], (char *) ch[der.store].buf+ch[der.store].nread,
			    2*der.nbuf-ch[der.store].nread);
  if (ch[der.store].nread>=2*der.nbuf) {
    bmin=5000; bmax=-5000; drawit=0;
    for(j=0; j<der.nbuf; j++) {
      wert=0; *w=ch[der.store].buf[2*j]; *(w+1)=ch[der.store].buf[2*j+1];
      // calculate moving average;
      dch[der.store].masum+=wert;
      dch[der.store].masum-=dch[der.store].mavg[map];
      ma=dch[der.store].masum/dch[der.store].movavg;
      dch[der.store].mavg[map]=wert; map++;
      if (map>=dch[der.store].movavg) map=0;
      // set godown;
      if (wert1>wert2) godown=1;
      if (wert1<wert2) godown=0;
      // check for minimum;
      if ((wert1>=wert2) && (wert2<ma) && godown) {
	lmin=wert2;
	godown=0;
      }
      dwert=ma-lmin;
      if(dwert<bmin) bmin=dwert;
      if(dwert>bmax) bmax=dwert;
      wert1=wert2; wert2=ma;
    }
    ch[der.store].nread-=2*der.nbuf;
    ch[der.store].min[ch[der.store].last]=bmin;
    ch[der.store].max[ch[der.store].last]=bmax;
    ch[der.store].last++;
    if (ch[der.store].last==der.xpix) {ch[der.store].last=0; ch[der.store].addfirst=1;}
    if (ch[der.store].addfirst) ch[der.store].first++;
    if (ch[der.store].first==der.xpix) ch[der.store].first=0;
  }

  if (drawit) der_redraw(draw_a);

  if (der.resize) {
    XtVaGetValues(draw_a, XmNwidth, &der.xpix, NULL);
    der.nbuf = der.length*reg.sr/der.xpix;
    if (der.nbuf<1) {
      der.nbuf=1;
      der.length=der.nbuf*der.xpix/reg.sr;
    }
    ch[der.store].buf = (char *)realloc(ch[der.store].buf, der.nbuf*2);
    ch[der.store].min = (int *)realloc(ch[der.store].min, der.xpix*sizeof(int));
    ch[der.store].max = (int *)realloc(ch[der.store].max, der.xpix*sizeof(int));
    ch[der.store].first=0; ch[der.store].last=0; ch[der.store].addfirst=0; ch[der.store].xpos=0;
    XClearWindow(XtDisplay(draw_a), XtWindow(draw_a));
    der.resize=0;
  }

  if (der.movavg!=dch[der.store].movavg) {
    dch[der.store].movavg=der.movavg;
    dch[der.store].mavg=(int *)realloc(dch[der.store].mavg, dch[der.store].movavg*sizeof(int));
    map=0;
    for (i=0; i<dch[der.store].movavg; i++) dch[der.store].mavg[i]=0;
  }

  return(0);
}

void dia_ok_cb(Widget widget, XtPointer client_data, XtPointer call_data) {
  struct my_msg_struct msg;
  Widget w;

  // mark button to indicate that there are derived channels;
  w=(Widget)client_data;
  if (dch[der.store].nch>0) XtVaSetValues(w, XmNlabelString, XmStringCreateLocalized("derived *"), NULL);
  else XtVaSetValues(w, XmNlabelString, XmStringCreateLocalized("derived  "), NULL);
  
  /* stop recording */
  msg.command=STOP_TASK; msg.value=0;
  write(fd8, &msg, sizeof(msg));
  msg.command=SET_SR; msg.value=1;
  write(fd8, &msg, sizeof(msg));
  msg.command=SET_CH; msg.value=0;
  write(fd8, &msg, sizeof(msg));
  msg.command=SET_POL; msg.value=0;
  write(fd8, &msg, sizeof(msg));
  XtRemoveWorkProc(work_id);
}

void dia_cancel_cb(Widget widget, XtPointer client_data, XtPointer call_data) {
  struct my_msg_struct msg;

  /* stop recording */
  msg.command=STOP_TASK; msg.value=0;
  write(fd8, &msg, sizeof(msg));
  msg.command=SET_SR; msg.value=1;
  write(fd8, &msg, sizeof(msg));
  msg.command=SET_CH; msg.value=0;
  write(fd8, &msg, sizeof(msg));
  msg.command=SET_POL; msg.value=0;
  write(fd8, &msg, sizeof(msg));
  XtRemoveWorkProc(work_id);
}


void der_redraw(Widget drawing_a) {
  GC         gc;
  Window     window=XtWindow(drawing_a);
  Display    *dpy=XtDisplay(drawing_a);
  Dimension  width, height;
  int        j, chn, dx, dy;

  extern void set_color(Widget, String, GC);

  gc=XCreateGC(XtDisplay(drawing_a), RootWindowOfScreen(XtScreen(drawing_a)), 0, NULL);
  set_color(drawing_a, TRIGGER_COLOR, gc);

  chn=der.store;
  XtVaGetValues(drawing_a, XmNwidth, &width, XmNheight, &height, NULL);

  dx=ch[chn].last-ch[chn].xpos;
  if (dx<0) dx+=der.xpix;
  if (dx>0) {
    if (!ch[chn].addfirst) {
      for (j=dx; j>0; j--) {
	XDrawLine(dpy, window, gc,
		  ch[chn].last-j,
		  height-height*dch[chn].ampli*ch[chn].min[ch[chn].last-j]/4095,
		  ch[chn].last-j,
		  height-height*dch[chn].ampli*ch[chn].max[ch[chn].last-j]/4095);
	XDrawPoint(dpy, window, gc, ch[chn].last-j, height-height*dch[chn].threshold/4095);
      }
      ch[chn].xpos=ch[chn].last;
    } // end addfirst;
    else {
      XCopyArea(dpy, window, window, gc,
		dx, 0, der.xpix-dx, height,
		0, 0);
      XClearArea(dpy, window, der.xpix-dx, 0, dx, height, False);
      for (j=0; j<dx; j++) {
	dy=ch[chn].last-dx+j;
	if (dy<0) dy+=der.xpix;
	XDrawLine(dpy, window, gc,
		  der.xpix-dx+j, height-height*dch[chn].ampli*ch[chn].min[dy]/4095,
		  der.xpix-dx+j, height-height*dch[chn].ampli*ch[chn].max[dy]/4095);
	XDrawPoint(dpy, window, gc, der.xpix-dx+j, height-height*dch[chn].threshold/4095);
      }
      ch[chn].xpos=ch[chn].last;
    } // end else addfirst;
  } // end if dx>0;
  
  XFreeGC(dpy,gc);
} 

void der_da_cb(Widget widget, XtPointer client_data, XtPointer call_data) {
  GC         gc;
  Window     window=XtWindow(widget);
  Display    *dpy=XtDisplay(widget);
  Dimension  width, height;
  int        chn, x, xpos;

  extern void set_color(Widget, String, GC);
  chn=der.store;

  XClearWindow(dpy, window);
  gc=XCreateGC(dpy, RootWindowOfScreen(XtScreen(drawing_a)), 0, NULL);
  XtVaGetValues(widget, XmNwidth, &width, XmNheight, &height, NULL);
  if (ch[chn].active) {
    set_color(widget, TRIGGER_COLOR, gc);
    x=ch[chn].first; xpos=0;
    while (x!=ch[chn].last) {
      XDrawLine(dpy, window, gc,
		xpos, height-height*dch[chn].ampli*ch[chn].min[x]/4095,
		xpos, height-height*dch[chn].ampli*ch[chn].max[x]/4095);
      x++; xpos++;
      if (x==der.xpix) x=0;
    }
  }
  XFreeGC(dpy,gc);
}

void der_rs_cb(Widget widget, XtPointer client_data, XtPointer call_data) {
    der.resize=1;
}

void threshold_cb(Widget widget, XtPointer client_data, XtPointer call_data) {
  XmScaleCallbackStruct *cbs = (XmScaleCallbackStruct *) call_data;
  dch[der.store].threshold=cbs->value;
}

void movavg_cb(Widget widget, XtPointer client_data, XtPointer call_data) {
  XmScaleCallbackStruct *cbs = (XmScaleCallbackStruct *) call_data;
  der.movavg=cbs->value;
}

void ampli_cb(Widget widget, XtPointer client_data, XtPointer call_data) {
  XmScaleCallbackStruct *cbs = (XmScaleCallbackStruct *) call_data;
  dch[der.store].ampli=cbs->value;
}

void tl_cb(Widget widget, XtPointer client_data, XtPointer call_data) {
  XmScaleCallbackStruct *cbs = (XmScaleCallbackStruct *) call_data;
  der.length=cbs->value;
  der.resize=1;
}

void set_limit_cb(Widget widget, XtPointer client_data, XtPointer call_data) {
  Widget *limitw, warn;
  char   *lowt, *hight;
  float  lowf, highf;
  int    dertype;

  limitw=(Widget *) client_data;
  XtVaGetValues(widget, XmNuserData, &dertype, NULL);
  lowt=XmTextGetString(limitw[0]);
  hight=XmTextGetString(limitw[1]);
  lowf=atof(lowt);
  highf=atof(hight);
  if (lowf >= highf) {
    // not valid;
    warn=XmCreateWarningDialog(XtParent(widget),"warning", NULL, 0);
    XtVaSetValues(XtParent(warn), XmNtitle, "values not valid!", NULL);
    XtVaSetValues(warn, XmNmessageString, XmStringCreateLtoR("lower limit must be smaller than upper limit!",XmFONTLIST_DEFAULT_TAG),NULL);
    XtUnmanageChild(XmMessageBoxGetChild(warn, XmDIALOG_HELP_BUTTON));
    XtUnmanageChild(XmMessageBoxGetChild(warn, XmDIALOG_CANCEL_BUTTON));
    XtManageChild(warn);
  }
  else {
    // valid;
    dch[der.store].ch[dertype].cal.rw_low=lowf;
    dch[der.store].ch[dertype].cal.rw_high=highf;
    dch[der.store].ch[dertype].cal.ad_low=0;
    dch[der.store].ch[dertype].cal.ad_high=4095;
    XtPopdown(XtParent(widget));
  }

  XtFree(lowt); XtFree(hight);
}

void cancel_limit_cb(Widget widget, XtPointer client_data, XtPointer call_data) {
  XtPopdown(XtParent(widget));
}
